<template>
  <span>{{ date }}</span>
</template>
<script lang="ts">
  import { defineComponent, ref, watch } from 'vue';
  import { useIntervalFn } from '@vueuse/core';
  import { formatToDateTime, formatToDate, dateUtil } from '@/utils/dateUtil';
  import { isNumber, isObject, isString } from '@/utils/is';
  import { propTypes } from '@/utils/propTypes';
  <%_ if (enableTranslation) { _%>
  import { useI18n } from '@/hooks/web/useI18n';
  <%_ } _%>

  const ONE_SECONDS = 1000;
  const ONE_MINUTES = ONE_SECONDS * 60;
  const ONE_HOUR = ONE_MINUTES * 60;
  const ONE_DAY = ONE_HOUR * 24;

  export default defineComponent({
    name: 'Time',
    props: {
      value: propTypes.oneOfType([propTypes.number, propTypes.instanceOf(Date), propTypes.string])
        .isRequired,
      step: propTypes.number.def(60),
      mode: propTypes.oneOf(['date', 'datetime', 'relative']).def('relative'),
    },
    setup(props) {
      const date = ref('');
        <%_ if (enableTranslation) { _%>

      const { t } = useI18n();
        <%_ } _%>

      useIntervalFn(setTime, props.step * ONE_SECONDS);

      watch(
        () => props.value,
        () => {
          setTime();
        },
        { immediate: true },
      );

      function getTime() {
        const { value } = props;
        let time = 0;
        if (isNumber(value)) {
          const timestamp = value.toString().length > 10 ? value : value * 1000;
          time = new Date(timestamp).getTime();
        } else if (isString(value)) {
          time = new Date(value).getTime();
        } else if (isObject(value)) {
          time = value.getTime();
        }
        return time;
      }

      function setTime() {
        const { mode, value } = props;
        const time = getTime();
        if (mode === 'relative') {
          date.value = getRelativeTime(time);
        } else {
          if (mode === 'datetime') {
            date.value = formatToDateTime(value);
          } else if (mode === 'date') {
            date.value = formatToDate(value);
          }
        }
      }

      function getRelativeTime(timeStamp: number) {
        const currentTime = new Date().getTime();

        // Determine whether the incoming timestamp is earlier than the current timestamp
        const isBefore = dateUtil(timeStamp).isBefore(currentTime);

        let diff = currentTime - timeStamp;
        if (!isBefore) {
          diff = -diff;
        }

        let resStr = '';
        <%_ if (enableTranslation) { _%>
        let dirStr = isBefore ? t('component.time.before') : t('component.time.after');
        <%_ } else { _%>
        let dirStr = isBefore ? 't$t('component.time.before')$t$' : 't$t('component.time.after')$t$';
        <%_ } _%>

        if (diff < ONE_SECONDS) {
          resStr = <% if (enableTranslation) { %>t('component.time.just')<% } else { %>'t$t('component.time.just')$t$'<% } %>;
          // Less than or equal to 59 seconds
        } else if (diff < ONE_MINUTES) {
          resStr = parseInt(diff / ONE_SECONDS) + <% if (enableTranslation) { %>t('component.time.seconds')<% } else { %>'t$t('component.time.seconds')$t$'<% } %> + dirStr;
          // More than 59 seconds, less than or equal to 59 minutes and 59 seconds
        } else if (diff >= ONE_MINUTES && diff < ONE_HOUR) {
          resStr = Math.floor(diff / ONE_MINUTES) + <% if (enableTranslation) { %>t('component.time.minutes')<% } else { %>'t$t('component.time.minutes')$t$'<% } %> + dirStr;
          // More than 59 minutes and 59 seconds, less than or equal to 23 hours, 59 minutes and 59 seconds
        } else if (diff >= ONE_HOUR && diff < ONE_DAY) {
          resStr = Math.floor(diff / ONE_HOUR) + <% if (enableTranslation) { %>t('component.time.hours')<% } else { %>'t$t('component.time.hours')$t$'<% } %> + dirStr;
          // More than 23 hours, 59 minutes and 59 seconds, less than or equal to 29 days, 59 minutes and 59 seconds
        } else if (diff >= ONE_DAY && diff < 2623860000) {
          resStr = Math.floor(diff / ONE_DAY) + <% if (enableTranslation) { %>t('component.time.days')<% } else { %>'t$t('component.time.days')$t$'<% } %> + dirStr;
          // More than 29 days, 59 minutes, 59 seconds, less than 364 days, 23 hours, 59 minutes, 59 seconds, and the incoming timestamp is earlier than the current
        } else if (diff >= 2623860000 && diff <= 31567860000 && isBefore) {
          resStr = dateUtil(timeStamp).format('MM-DD-HH-mm');
        } else {
          resStr = dateUtil(timeStamp).format('YYYY');
        }
        return resStr;
      }

      return { date };
    },
  });
</script>
